import uuid
from sqlalchemy import Column, DateTime, ForeignKey, String, Uuid

from app.database import Base

class Session(Base):
    __tablename__ = "sessions"

    id = Column(Uuid, primary_key=True, default=uuid.uuid4)
    name = Column(String)
    refresh_token = Column(String, nullable=False, unique=True, index=True)
    last_used = Column(DateTime(timezone=True))

    user_id = Column(Uuid, ForeignKey("users.id"), nullable=False, index=True)