from dataclasses import dataclass
from datetime import datetime
from pydantic import BaseModel

from app.schemas.user import Role


@dataclass
class AccessToken:
    subject: str
    role: Role
    session: str

class TokenRefreshRequest(BaseModel):
    refresh_token: str


class TokenResponse(BaseModel):
    access_token: str
    refresh_token: str
    not_after: datetime
