import enum
from uuid import UUID
from pydantic import BaseModel

class ConnectorStatus(enum.Enum):
    AVAILABLE = "Available"
    OCCUPIED = "Occupied"
    RESERVED = "Reserved"
    UNAVAILABLE = "Unavailable"
    FAULTED = "Faulted"

class Connector(BaseModel):
    id: UUID
    evse: int
    index: int
    status: ConnectorStatus
    
    class Config:
        from_attributes = True